--[[-- Copyright (c) 2026 Huawei Technologies Co., Ltd.
-- openUBMC is licensed under Mulan PSL v2.
-- You can use this software according to the terms and conditions of the Mulan PSL v2.
-- You may obtain a copy of Mulan PSL v2 at:
--          http://license.coscl.org.cn/MulanPSL2
-- THIS SOFTWARE IS PROVIDED ON AN "AS IS" BASIS, WITHOUT WARRANTIES OF ANY KIND,
-- EITHER EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO NON-INFRINGEMENT,
-- MERCHANTABILITY OR FIT FOR A PARTICULAR PURPOSE.
-- See the Mulan PSL v2 for more details.
]] --
local validate = require 'mc.validate'
local utils = require 'mc.utils'

local SetSlotPowerState = {}

---@class StorageIpmiCmds.SetSlotPowerStateReq
---@field ManufacturerId integer
---@field Reserve integer
---@field DriveId integer
---@field Frame integer
---@field WritingOffset integer
---@field WritingLength integer
---@field Data integer
local TSetSlotPowerStateReq = {}
TSetSlotPowerStateReq.__index = TSetSlotPowerStateReq
TSetSlotPowerStateReq.group = {}

local function TSetSlotPowerStateReq_from_obj(obj)
    return setmetatable(obj, TSetSlotPowerStateReq)
end

function TSetSlotPowerStateReq.new(ManufacturerId, Reserve, DriveId, Frame, WritingOffset, WritingLength, Data)
    return TSetSlotPowerStateReq_from_obj({
        ManufacturerId = ManufacturerId,
        Reserve = Reserve,
        DriveId = DriveId,
        Frame = Frame,
        WritingOffset = WritingOffset,
        WritingLength = WritingLength,
        Data = Data
    })
end
---@param obj StorageIpmiCmds.SetSlotPowerStateReq
function TSetSlotPowerStateReq:init_from_obj(obj)
    self.ManufacturerId = obj.ManufacturerId
    self.Reserve = obj.Reserve
    self.DriveId = obj.DriveId
    self.Frame = obj.Frame
    self.WritingOffset = obj.WritingOffset
    self.WritingLength = obj.WritingLength
    self.Data = obj.Data
end

function TSetSlotPowerStateReq:remove_error_props(errs, obj)
    utils.remove_obj_error_property(obj, errs, TSetSlotPowerStateReq.group)
end

TSetSlotPowerStateReq.from_obj = TSetSlotPowerStateReq_from_obj

TSetSlotPowerStateReq.proto_property = {
    'ManufacturerId', 'Reserve', 'DriveId', 'Frame', 'WritingOffset', 'WritingLength', 'Data'
}

TSetSlotPowerStateReq.default = {0, 0, 0, 0, 0, 0, 0}

TSetSlotPowerStateReq.struct = {
    {name = 'ManufacturerId', is_array = false, struct = nil}, {name = 'Reserve', is_array = false, struct = nil},
    {name = 'DriveId', is_array = false, struct = nil}, {name = 'Frame', is_array = false, struct = nil},
    {name = 'WritingOffset', is_array = false, struct = nil}, {name = 'WritingLength', is_array = false, struct = nil},
    {name = 'Data', is_array = false, struct = nil}
}

function TSetSlotPowerStateReq:validate(prefix, errs, need_convert)
    prefix = prefix or ''

    validate.Optional(prefix .. 'ManufacturerId', self.ManufacturerId, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'Reserve', self.Reserve, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'DriveId', self.DriveId, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'Frame', self.Frame, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'WritingOffset', self.WritingOffset, 'uint16', false, errs, need_convert)
    validate.Optional(prefix .. 'WritingLength', self.WritingLength, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'Data', self.Data, 'uint8', false, errs, need_convert)

    TSetSlotPowerStateReq:remove_error_props(errs, self)
    validate.CheckUnknowProperty(self, TSetSlotPowerStateReq.proto_property, errs, need_convert)
    return self
end

function TSetSlotPowerStateReq:unpack(_)
    return self.ManufacturerId, self.Reserve, self.DriveId, self.Frame, self.WritingOffset, self.WritingLength,
        self.Data
end

SetSlotPowerState.SetSlotPowerStateReq = TSetSlotPowerStateReq

---@class StorageIpmiCmds.SetSlotPowerStateRsp
---@field CompletionCode integer
---@field ManufactureId integer
---@field Reserve integer
local TSetSlotPowerStateRsp = {}
TSetSlotPowerStateRsp.__index = TSetSlotPowerStateRsp
TSetSlotPowerStateRsp.group = {}

local function TSetSlotPowerStateRsp_from_obj(obj)
    return setmetatable(obj, TSetSlotPowerStateRsp)
end

function TSetSlotPowerStateRsp.new(CompletionCode, ManufactureId, Reserve)
    return TSetSlotPowerStateRsp_from_obj({
        CompletionCode = CompletionCode,
        ManufactureId = ManufactureId,
        Reserve = Reserve
    })
end
---@param obj StorageIpmiCmds.SetSlotPowerStateRsp
function TSetSlotPowerStateRsp:init_from_obj(obj)
    self.CompletionCode = obj.CompletionCode
    self.ManufactureId = obj.ManufactureId
    self.Reserve = obj.Reserve
end

function TSetSlotPowerStateRsp:remove_error_props(errs, obj)
    utils.remove_obj_error_property(obj, errs, TSetSlotPowerStateRsp.group)
end

TSetSlotPowerStateRsp.from_obj = TSetSlotPowerStateRsp_from_obj

TSetSlotPowerStateRsp.proto_property = {'CompletionCode', 'ManufactureId', 'Reserve'}

TSetSlotPowerStateRsp.default = {0, 0, 0}

TSetSlotPowerStateRsp.struct = {
    {name = 'CompletionCode', is_array = false, struct = nil}, {name = 'ManufactureId', is_array = false, struct = nil},
    {name = 'Reserve', is_array = false, struct = nil}
}

function TSetSlotPowerStateRsp:validate(prefix, errs, need_convert)
    prefix = prefix or ''

    validate.Optional(prefix .. 'CompletionCode', self.CompletionCode, 'uint8', false, errs, need_convert)
    validate.Optional(prefix .. 'ManufactureId', self.ManufactureId, 'uint32', false, errs, need_convert)
    validate.Optional(prefix .. 'Reserve', self.Reserve, 'uint32', false, errs, need_convert)

    TSetSlotPowerStateRsp:remove_error_props(errs, self)
    validate.CheckUnknowProperty(self, TSetSlotPowerStateRsp.proto_property, errs, need_convert)
    return self
end

function TSetSlotPowerStateRsp:unpack(_)
    return self.CompletionCode, self.ManufactureId, self.Reserve
end

SetSlotPowerState.SetSlotPowerStateRsp = TSetSlotPowerStateRsp

return SetSlotPowerState
